#ifndef GUIGFX_H
#define GUIGFX_H	1


#include "exec/exec.h"
#include "graphics/view.h"


extern struct Library *RenderBase;


struct PenShareMap
{
	APTR	memhandler;	/* Memhandler for this PenShareMap */
	APTR	histogram;	/* This PenShareMap's private histogram */
	APTR	colormap;	/* The colormap to adapt to */

	APTR	mainpalette;
	UWORD	mainnumcolors;	/* Number of colors in main palette */
	UBYTE	*mainpentab;	/* Main pen-allocation table */

	APTR	basepalette;
	UWORD	basenumcolors;	/* Number of colors in base palette */
	UBYTE	*basepentab;	/* Base pen-allocation table */
};

struct ThumbNail
{
	APTR	memhandler;		/* Thumbnail's memhandler */
	UBYTE	*image;			/* Chunky image */
	UWORD	width,height;	/* Chunky image's dimensions */
	ULONG	palette[256];	/* Chunky image's palette */
};


extern struct PenShareMap *CreatePenShareMap(void);
extern BOOL ObtainPenShareMap(struct PenShareMap *psm,struct ColorMap *cm,ULONG precision);
extern void ReleasePenShareMap(struct PenShareMap *psm);
extern void DeletePenShareMap(struct PenShareMap *psm);
void RemapChunkyArray ( UBYTE *source, APTR palette, UWORD width, UWORD height, UBYTE *dest, struct PenShareMap *psm);
void DrawChunkyArray ( struct RastPort *rp, UBYTE *array, UWORD x, UWORD y, UWORD width, UWORD height );

#endif
